// -*- C++ -*-
//
// $Id$

// ****  Code generated by the The ACE ORB (TAO) IDL Compiler ****
// TAO and the TAO IDL Compiler have been developed by:
//       Center for Distributed Object Computing
//       Washington University
//       St. Louis, MO
//       USA
//       http://www.cs.wustl.edu/~schmidt/doc-center.html
// and
//       Distributed Object Computing Laboratory
//       University of California at Irvine
//       Irvine, CA
//       USA
//       http://doc.ece.uci.edu/
// and
//       Institute for Software Integrated Systems
//       Vanderbilt University
//       Nashville, TN
//       USA
//       http://www.isis.vanderbilt.edu/
//
// Information about TAO is available at:
//     http://www.cs.wustl.edu/~schmidt/TAO.html

// TAO_IDL - Generated from
// be/be_codegen.cpp:565

#ifndef _TAO_IDL_FT_CORBAS_T_H_
#define _TAO_IDL_FT_CORBAS_T_H_

#include /**/ "ace/pre.h"

TAO_BEGIN_VERSIONED_NAMESPACE_DECL



// TAO_IDL - Generated from 
// be/be_visitor_root/root_sth.cpp:116

namespace POA_FT
{
  
  // TAO_IDL - Generated from
  // be/be_visitor_interface/tie_sh.cpp:87
  
  // TIE class: Refer to CORBA v2.2, Section 20.34.4
  template <class T>
  class  FTObjectGroupManager_tie : public FTObjectGroupManager
  {
  public:
    /// the T& ctor
    FTObjectGroupManager_tie (T &t);
    /// ctor taking a POA
    FTObjectGroupManager_tie (T &t, PortableServer::POA_ptr poa);
    /// ctor taking pointer and an ownership flag
    FTObjectGroupManager_tie (T *tp, ::CORBA::Boolean release = true);
    /// ctor with T*, ownership flag and a POA
    FTObjectGroupManager_tie (
        T *tp,
        PortableServer::POA_ptr poa,
        ::CORBA::Boolean release = true
      );
    /// dtor
    
    ~FTObjectGroupManager_tie (void);
    // TIE specific functions
    /// return the underlying object
    T *_tied_object (void);
    /// set the underlying object
    void _tied_object (T &obj);
    /// set the underlying object and the ownership flag
    void _tied_object (T *obj, ::CORBA::Boolean release = true);
    /// do we own it
    ::CORBA::Boolean _is_owner (void);
    /// set the ownership
    
    void _is_owner ( ::CORBA::Boolean b);
    // overridden ServantBase operations
    PortableServer::POA_ptr _default_POA (
        ACE_ENV_SINGLE_ARG_DECL_WITH_DEFAULTS
      );
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::PortableGroup::ObjectGroup_ptr create_member (
        ::PortableGroup::ObjectGroup_ptr object_group,
        const ::PortableGroup::Location & the_location,
        const char * type_id,
        const ::PortableGroup::Criteria & the_criteria
        ACE_ENV_ARG_DECL_WITH_DEFAULTS
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::PortableGroup::ObjectGroupNotFound,
        ::PortableGroup::MemberAlreadyPresent,
        ::PortableGroup::NoFactory,
        ::PortableGroup::ObjectNotCreated,
        ::PortableGroup::InvalidCriteria,
        ::PortableGroup::CannotMeetCriteria
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::PortableGroup::ObjectGroup_ptr add_member (
        ::PortableGroup::ObjectGroup_ptr object_group,
        const ::PortableGroup::Location & the_location,
        ::CORBA::Object_ptr member
        ACE_ENV_ARG_DECL_WITH_DEFAULTS
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::PortableGroup::ObjectGroupNotFound,
        ::PortableGroup::MemberAlreadyPresent,
        ::PortableGroup::ObjectNotAdded
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::PortableGroup::ObjectGroup_ptr remove_member (
        ::PortableGroup::ObjectGroup_ptr object_group,
        const ::PortableGroup::Location & the_location
        ACE_ENV_ARG_DECL_WITH_DEFAULTS
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::PortableGroup::ObjectGroupNotFound,
        ::PortableGroup::MemberNotFound
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::PortableGroup::Locations * locations_of_members (
        ::PortableGroup::ObjectGroup_ptr object_group
        ACE_ENV_ARG_DECL_WITH_DEFAULTS
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::PortableGroup::ObjectGroupNotFound
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::PortableGroup::ObjectGroups * groups_at_location (
        const ::PortableGroup::Location & the_location
        ACE_ENV_ARG_DECL_WITH_DEFAULTS
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::PortableGroup::ObjectGroupId get_object_group_id (
        ::PortableGroup::ObjectGroup_ptr object_group
        ACE_ENV_ARG_DECL_WITH_DEFAULTS
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::PortableGroup::ObjectGroupNotFound
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::PortableGroup::ObjectGroup_ptr get_object_group_ref (
        ::PortableGroup::ObjectGroup_ptr object_group
        ACE_ENV_ARG_DECL_WITH_DEFAULTS
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::PortableGroup::ObjectGroupNotFound
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::CORBA::Object_ptr get_member_ref (
        ::PortableGroup::ObjectGroup_ptr object_group,
        const ::PortableGroup::Location & loc
        ACE_ENV_ARG_DECL_WITH_DEFAULTS
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::PortableGroup::ObjectGroupNotFound,
        ::PortableGroup::MemberNotFound
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::PortableGroup::ObjectGroup_ptr get_object_group_ref_from_id (
        ::PortableGroup::ObjectGroupId group_id
        ACE_ENV_ARG_DECL_WITH_DEFAULTS
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::PortableGroup::ObjectGroupNotFound
      ));
    
    // TAO_IDL - Generated from
    // be/be_visitor_operation/tie_sh.cpp:60
    
    ::PortableGroup::ObjectGroup_ptr set_primary_member (
        ::PortableGroup::ObjectGroup_ptr object_group,
        const ::PortableGroup::Location & the_location
        ACE_ENV_ARG_DECL_WITH_DEFAULTS
      )
      ACE_THROW_SPEC ((
        ::CORBA::SystemException,
        ::PortableGroup::ObjectGroupNotFound,
        ::PortableGroup::MemberNotFound,
        ::FT::PrimaryNotSet,
        ::FT::BadReplicationStyle
      ));
  
  private:
    T *ptr_;
    PortableServer::POA_var poa_;
    ::CORBA::Boolean rel_;
    
    // copy and assignment are not allowed
    FTObjectGroupManager_tie (const FTObjectGroupManager_tie &);
    void operator= (const FTObjectGroupManager_tie &);
  };
} // module FT

// TAO_IDL - Generated from 
// be/be_codegen.cpp:1300


TAO_END_VERSIONED_NAMESPACE_DECL



#if defined (ACE_TEMPLATES_REQUIRE_SOURCE)
#include "FT_CORBAS_T.cpp"
#endif /* defined REQUIRED SOURCE */

#if defined (ACE_TEMPLATES_REQUIRE_PRAGMA)
#pragma implementation ("FT_CORBAS_T.cpp")
#endif /* defined REQUIRED PRAGMA */

#include /**/ "ace/post.h"
#endif /* ifndef */

